//! Specialized hinge class.

/*!
 * Predefined hinge class. Ready to use in a RobotActor.
 *
 * @author Lutz Winkler
 *
 */



#ifndef MYHINGE_H_
#define MYHINGE_H_

#include <srCore/actuator/hingeActuator.h>

namespace srCore {

class HingeUniKarl : public HingeActuator
{
public:

	//! Constructor
	/*! @param body1, body2 					the bodies the hinge is attached to.
	 * 	@param anchorX, anchorY, anchorZ 		the position of the hinge in the world coordinate system.
	 *  @param axisX, axisY, axisZ 				the orientation of the axis of the hinge in the world coordinate system.
	 *
	 */
	HingeUniKarl(dtCore::RefPtr<BodyBase> myBody1, dtCore::RefPtr<BodyBase> myBody2,
			float anchorX, float anchorY, float anchorZ,
			float axisX, float axisY, float axisZ,
			const std::string &hingeName = "ukaHinge");

	virtual ~HingeUniKarl();



};
}
#endif /*MYHINGE_H_*/
