//! Specialized hinge class.

/*!
 * Predefined hinge class. Ready to use in a RobotActor.
 * This class can be used as a class for unsteerable wheel joints.
 *
 * @author Lutz Winkler
 *
 */

#ifndef MYWHEEL_H_
#define MYWHEEL_H_

#include <srCore/actuator/hingeActuator.h>

namespace srCore {


class WheelUniKarl : public HingeActuator			//WheelActuator
{
public:

	//! Constructor
	/*! @param body1, body2 					the bodies the hinge is attached to.
	 * 	@param anchorX, anchorY, anchorZ 		the position of the hinge in the world coordinate system.
	 *  @param axisX, axisY, axisZ 				the orientation of the axis of the hinge in the world coordinate system.
	 *
	 */
	WheelUniKarl(dtCore::RefPtr<BodyBase> myBody1, dtCore::RefPtr<BodyBase> myBody2,
				float anchorX, float anchorY, float anchorZ,
				float axisX, float axisY, float axisZ,
				const std::string &name="ukaWheel");

	virtual ~WheelUniKarl();

	virtual void update(float deltaSimTme) {};

};
}
#endif /*MYHINGE_H_*/
