//! Specialized body class.

/*!
 * Predefined connector class. Ready to use in a RobotActor.
 *
 * @author Lutz Winkler
 *
 */

#ifndef MYCONNECTOR_H_
#define MYCONNECTOR_H_

#include <srCore/actuator/connectorBase.h>

//TODO: Do we need an extra connector class?

namespace srCore {

class myConnector : public ConnectorBase
{
public:

	//! Constructor
		/*! @param body							the body, where the connector is attached to
		 * 	@param anchorX, anchorY, anchorZ 	the position of the hinge in the body coordinate system.
		 *  @param axisX, axisY, axisZ	 		the orientation of the axis of the hinge in the body coordinate system.
		 *  @param Scene 						the scene in which the body should be placed.
		 *  @param gm							the GameManager that handles the corresponding robot
		 *  @param name							the name of the connector
		 *
		 */
	myConnector(dtCore::RefPtr<BodyBase> body,
			float anchorX, float anchorY, float anchorZ,
			float axisX, float axisY, float axisZ, const std::string &name = "ukaConnector");

	virtual ~myConnector();
};

}

#endif /*MYCONNECTOR_H_*/
