//! Specialized body class.

/*!
 * Predefined body class. Ready to use in a RobotActor.
 * This body represents the middle part of the former robot of UniKarl, constructed by Ramon.
 *
 * @author Lutz Winkler
 *
 */

#ifndef LINKBODY_H_
#define LINKBODY_H_

#include <srCore/body/cuboid.h>

namespace srCore {

//! obsolete class as this robot is not available anymore (robot, designed by Ramon)
class LinkBody : public Cuboid
{
public:

	//! Constructor
	/*! @param id 								a 16bit id, used to set the colliding bit parameter.
	 * 	@param x, y, z 							the position of the hinge in the world coordinate system.
	 *  @param heading, pitch, roll 			the orientation of the axis of the hinge in the world coordinate system.
	 *  @param Scene 							the scene in which the body should be placed.
	 *  @param osgGroup					using this group, another scene will be created that will be used by sensors
	 *
	 */
	LinkBody(	RobotActorBase* robot,
				float x, float y, float z,
				float heading, float pitch, float roll);

protected:
	virtual ~LinkBody();

};
}
#endif /*LINKBODY_H_*/
