#ifndef SOCKETBODY_H_
#define SOCKETBODY_H_

#include "../../basic/bodies/cuboid.h"

namespace srCore {

/**
 * The SocketBody is derived from Cuboid. Easiest and might eventually use the collision
 * box of a cube.
 */
class SocketBody : public Cuboid {
public:

	/*! 
	 * A SocketBody is attached to a RobotActorBase as explained elsewhere. It makes it
	 * easier to add additional functionality.
	 * @param robot 					robot identifier
	 * @param x, y, z 					world coordinate position of the socket 
	 * @param heading, pitch, roll		world coordinate orientation of the socket 
	 */
	SocketBody(	RobotActorBase* robot,
				float x, float y, float z,
				float heading, float pitch, float roll);

	virtual ~SocketBody();

};

}

#endif /*SOCKETBODY_H_*/
