//! Specialized body class.

/*!
 * Predefined body class. Ready to use in a RobotActor.
 * This body represents one of two parts of the current robot of UniKarl.
 *
 * @author Lutz Winkler
 *
 */

#ifndef SYMBRIONBODY02_H_
#define SYMBRIONBODY02_H_

#include <srCore/body/cuboid.h>

namespace srCore {

class SymbrionBodyII : public Cuboid
{
public:

	//! Constructor
	/*! @param id 						a 16bit id, used to set the colliding bit parameter.
	 * 	@param x, y, z 					the position of the hinge in the world coordinate system.
	 *  @param heading, pitch, roll		the orientation of the axis of the hinge in the world coordinate system.
	 *  @param Scene 					the scene in which the body should be placed.
	 *  @param osgGroup					using this group, another scene will be created that will be used by sensors
	 *
	 */
	SymbrionBodyII(	RobotActorBase* robot,
				float x, float y, float z,
				float heading, float pitch, float roll);

protected:
	virtual ~SymbrionBodyII();

};
}
#endif /*SYMBRIONBODY02_H_*/
