//! Specialized body class.

/*!
 * Predefined body class. Ready to use in a RobotActor.
 * This body represents the wheels of a	 robot.
 *
 * @author Lutz Winkler
 *
 */

#ifndef WANDA_WHEEL_H_
#define WANDA_WHEEL_H_

#include "../../basic/bodies/cylinder.h"

namespace srCore {

class WandaWheel : public Cylinder
{
public:
	//! Constructor
	/*! @param id 						a 16bit id, used to set the colliding bit parameter.
	 * 	@param x, y, z 					the position of the hinge in the world coordinate system.
	 *  @param heading, pitch, roll 	the orientation of the axis of the hinge in the world coordinate system.
	 *  @param Scene 					the scene in which the body should be placed.
	 *  @param osgGroup					using this group, another scene will be created that will be used by sensors
	 *
	 */
	WandaWheel(	RobotActorBase* robot,
			float x, float y, float z,
			float heading, float pitch, float roll);

	virtual ~WandaWheel();
};
}
#endif /*WANDA_WHEEL_H_*/
