//! Basic wheel class.

/*!
 *
 * This class simulates a steerable wheel. It uses the ode Hinge2 joint.
 *
 * Note: Currently this class is not in use and therefore not up-to-date or even valid.
 *
 * @author Lutz Winkler
 *
 */

#ifndef WHEELACTOR_H_
#define WHEELACTOR_H_

#include <dtCore/dt.h>
#include <dtCore/object.h>
#include <dtCore/globals.h>
#include <dtCore/transform.h>
#include <dtGame/gameactor.h>
#include <dtCore/refptr.h>


#include <osg/Node>
#include <osgDB/ReadFile>

#include <ode/ode.h>

#include "actuatorBase.h"

namespace srCore {

class WheelActuator : public ActuatorBase
{
public:
	WheelActuator(const std::string name,  const std::string type);
	virtual ~WheelActuator();

	//! initializes the connector. Needs to be called before using the wheel.
	void init(	dtCore::RefPtr<BodyBase> myBody1, dtCore::RefPtr<BodyBase> myBody2,
				float anchorX, float anchorY, float anchorZ,
				float axis1_X, float axis1_Y, float axis1_Z,
				float axis2_X, float axis2_Y, float axis2_Z);

	//Todo: one time there should not be the need anymore to access the joint directly:
	dJointID getWheel();

	void registerActuator();

	//! Sets ode parameters for the joint. For more Information, see www.ode.org/ode-latest-user-guide.org.
	void setODEParameter(int parameter, float value);

protected:
	dJointID joint;
};

}

#endif /*WHEELACTOR_H_*/
