//! General cuboid class.

/*!
 *
 * Describes general properties of a cuboid (or a box) in the simulation environment.
 *
 * @author Lutz Winkler
 *
 */

#ifndef CUBOID_H_
#define CUBOID_H_


#include "bodyBase.h"

namespace srCore {

class Cuboid : public BodyBase
{
public:
	//! Constructor
	Cuboid();

	//! sets the collision parameter of the cuboid
	void setCollisionBox(float length, float width, float height);

	//! sets the mass with a equal mass distribution in a cuboid with the given parameters
	void setMass(float mass, float length, float width, float height);
protected:
	virtual ~Cuboid();

private:
	float collisionLength, collisionWidth, collisionHeight;

};
}

#endif /*CUBOID_H_*/
