//! General cylinder class.

/*!
 *
 * Describes general properties of a cylinder.
 *
 * @author Lutz Winkler
 *
 */

#ifndef CYLINDER_H_
#define CYLINDER_H_

#include "bodyBase.h"

namespace srCore {

class Cylinder : public BodyBase
{
public:
	//! Constructor
	Cylinder();

	//! sets the collision parameter of the cylinder.
	void setCollisionCylinder(float radius, float length);

	//! sets the mass with a equal mass distribution within the parameters defined in setCollisionCylinder.
	void setMass(float mass);

	//! sets the mass with a equal mass distribution in a cylinder with the given parameters
	void setMass(float mass, float radius, float length);
protected:
	virtual ~Cylinder();

private:
	float collisionRadius, collisionLength;

};
}

#endif /*CYLINDER_H_*/
