/**
 * @file RobotCreator.h
 * @brief 
 *
 * This file RobotCreator.h is created at Almende B.V. It is open-source software and part
 * of the Common Hybrid Agent Platform (CHAP). A toolbox with a lot of open-source tools.
 * Ranging from thread pools, and TCP/IP components to control architectures and learning
 * algorithms. This software is published under the GNU Lesser General Public license,
 * but the software is not allowed to be used for military use, within the bio-industry
 * or for animal experimentation.
 *
 * @author  Anne C. van Rossum
 * @date    Jul 13, 2010
 * @project Replicator FP7
 * @company Almende B.V.
 * @case	
 */


#ifndef ROBOTCREATOR_H_
#define ROBOTCREATOR_H_

// General files
#include <srCore/singleton.h>
#include <srCore/xmlConfig.h>

namespace srCore {

/**
 * \addtogroup Default
 * @{
 */

/* **************************************************************************************
 * Interface of RobotCreator
 * **************************************************************************************/

/**
 * Creates robots and adds them to the game manager.
 */
class RobotCreator {
private:

protected:

public:
	//! Constructor
	RobotCreator();

	//! Destructor
	virtual ~RobotCreator();

	//! Adds robot to the game manager
	bool addRobotToGM(int id, const RobotInitData &parameters, float height);
};

///@}


typedef Singleton<RobotCreator> SimulationRobotCreator;

}

#endif /* ROBOTCREATOR_H_ */
