/*
 * Component for robot selection
 *
 * @author Adrian Friebel
 */

#ifndef SIMULATIONROBOTSELECTIONCOMPONENT_H_
#define SIMULATIONROBOTSELECTIONCOMPONENT_H_

// Delta3D files
#include <dtGame/gmcomponent.h>
#include <dtDAL/gameeventmanager.h>

// Robot3D files
#include <srCore/export.h>

/**
 * Makes it possible to select a robot in the GUI.
 */
class ROBOT_EXPORT SimulationRobotSelectionComponent : public dtGame::GMComponent
{
   public:
	  SimulationRobotSelectionComponent(const std::string &name, int robFoc);
      void ProcessMessage(const dtGame::Message &message);
      void init();
      
      int getRobFocIndex() {return robotFocusIndex; };
      

   protected:
      virtual ~SimulationRobotSelectionComponent() { }

   private:
      void sendMessageToAll(dtDAL::GameEvent &event);

      dtCore::RefPtr<dtDAL::GameEvent> mFocusChanged;

      int robotFocus;

      int robotFocusIndex;
};

#endif /*SIMULATIONROBOTSELECTIONCOMPONENT_H_*/
