/*
 * distanceSensor.h
 *
 *  Created on: Dec 29, 2008
 *      Author: winkler
 */

#ifndef DISTANCESENSOR_H_
#define DISTANCESENSOR_H_



#include "cameraSensorBase.h"

namespace srCore {

class DistanceSensor: public CameraSensorBase
{
public:

	/**
		 * \brief  Initializes the sensor
		 *
		 * \param			gm							GameManager, which handles the corresponding robot
		 * \param			attachedTo					Body, where the sensor is attached to
		 * \param     		pos			   				Local position of the sensor
		 * \param			orient 						Local orientation of the sensor
		 * \param			flareAngle					flare angle of the sensor
		 * \param			name						name of the sensor
		 *
		 *
		 */
	DistanceSensor(dtCore::RefPtr<BodyBase> attachedTo, osg::Vec3 pos, osg::Vec3 orient, float flareAngle, const std::string &name="DistanceSensor");
	//const std::string TakeScreenShot(const std::string& namePrefix);

	//! sends command to retrieve data
	void evaluate(ParameterReturnValue srv);
	
protected:
	virtual ~DistanceSensor();

	virtual void getNewSensorValue();

protected:
	virtual void getSensorValue(std::ostream& theStream) const;

private:
	unsigned int value;



};

}

#endif /* DISTANCESENSOR_H_ */
