/**
 *  All Event Messages that can occur in the simulation need to be declared here.
 */

#ifndef SIMULATIONEVENTS_H_
#define SIMULATIONEVENTS_H_



//! move fwd/bwd resp. accelerate/deccelerate actuator
const char* const MOVE_ACTUATOR1_FWD		=		"MoveActuator1Fwd";
const char* const MOVE_ACTUATOR1_BWD		=		"MoveActuator1Bwd";

const char* const MOVE_ACTUATOR2_FWD		=		"MoveActuator2Fwd";
const char* const MOVE_ACTUATOR2_BWD		=		"MoveActuator2Bwd";

const char* const MOVE_ACTUATOR3_FWD		=		"MoveActuator3Fwd";
const char* const MOVE_ACTUATOR3_BWD		=		"MoveActuator3Bwd";

const char* const MOVE_ACTUATOR4_FWD		=		"MoveActuator4Fwd";
const char* const MOVE_ACTUATOR4_BWD		=		"MoveActuator4Bwd";



//! connector has to connect/disconnect
const char* const CONNECT_CONNECTOR1		=		"ConnectConnector1";
const char* const DISCONNECT_CONNECTOR1		=		"DisconnectConnector1";

const char* const CONNECT_CONNECTOR2		=		"ConnectConnector2";
const char* const DISCONNECT_CONNECTOR2		=		"DisconnectConnector2";

const char* const CONNECT_CONNECTOR3		=		"ConnectConnector3";
const char* const DISCONNECT_CONNECTOR3		=		"DisconnectConnector3";

const char* const CONNECT_CONNECTOR4		=		"ConnectConnector4";
const char* const DISCONNECT_CONNECTOR4		=		"DisconnectConnector4";

const char* const CONNECT_CONNECTOR5		=		"ConnectConnector5";
const char* const DISCONNECT_CONNECTOR5		=		"DisconnectConnector5";

const char* const CONNECT_CONNECTOR6		=		"ConnectConnector6";
const char* const DISCONNECT_CONNECTOR6		=		"DisconnectConnector6";

const char* const CONNECT_ALL				=		"ConnectAll";
const char* const DISCONNECT_ALL			=		"DisconnectAll";


//! sensor retrieved a new value
const char* const SENSOR1_NEW_VALUE		=		"Sensor1NewValue";
const char* const SENSOR2_NEW_VALUE		=		"Sensor2NewValue";
const char* const SENSOR3_NEW_VALUE		=		"Sensor3NewValue";
const char* const SENSOR4_NEW_VALUE		=		"Sensor4NewValue";
const char* const SENSOR5_NEW_VALUE		=		"Sensor5NewValue";
const char* const SENSOR6_NEW_VALUE		=		"Sensor6NewValue";
const char* const SENSOR7_NEW_VALUE		=		"Sensor7NewValue";
const char* const SENSOR8_NEW_VALUE		=		"Sensor8NewValue";
const char* const SENSOR9_NEW_VALUE		=		"Sensor9NewValue";



//! change sensor attributes
const char* const CAMERA1_ZOOM_IN			=		"Camera1ZoomIn";
const char* const CAMERA1_ZOOM_OUT			=		"Camera1ZoomOut";
const char* const CAMERA1_MOVE_RIGHT		=		"Camera1MoveRight";
const char* const CAMERA1_MOVE_LEFT			=		"Camera1MoveLeft";
const char* const CAMERA1_MOVE_UP			=		"Camera1MoveUp";
const char* const CAMERA1_MOVE_DOWN			=		"Camera1MoveDown";
const char* const CAMERA1_SAVE_IMAGE		=		"Camera1SaveImage";

const char* const CAMERA2_ZOOM_IN			=		"Camera2ZoomIn";
const char* const CAMERA2_ZOOM_OUT			=		"Camera2ZoomOut";
const char* const CAMERA2_MOVE_RIGHT		=		"Camera2MoveRight";
const char* const CAMERA2_MOVE_LEFT			=		"Camera2MoveLeft";
const char* const CAMERA2_MOVE_UP			=		"Camera2MoveUp";
const char* const CAMERA2_MOVE_DOWN			=		"Camera2MoveDown";



//! properties for simulation handling
const char* const TIME_SCALE_CHANGED		=	"TimeScaleChanged";
const char* const SELECT_ROBOT				=	"SelectRobot";
const char* const CHANGE_ROBOT_SELECTION	=	"ChangeRobotSelection";
const char* const ROBOT_SELECTION_CHANGED	=	"RobotSelectionChanged";
const char* const MOUSE_LEFT_CLICK  		=   "MouseLBClick";
const char* const TAKE_SCREEN_SHOT_TOGGLE	=	"TakeScreenShotToggle";
const char* const SWITCH_CONTROL			=	"SwitchControl";
const char* const PAUSE_SIM					=	"PauseSim";
const char* const RESET_SIM					=	"ResetSim";
const char* const DESTROY_ALL_ACTOR			=   "DestroyAllActor";
const char* const DESTROY_ACTOR				=   "DestroyActor";
const char* const CREATE_ACTOR				=   "CreateActor";
const char* const ACTOR_DESTROYED			=   "ActorDestroyed";

//! events for camera control
const char* const MOUSE_IN_GUI				=	"MouseInGUI";
const char* const MOUSE_IN_SIM				=	"MouseInSim";
const char* const CHANGE_CAMERA_MODE		=	"ChangeCameraMode";

//! events for controller control
#ifdef PARTNER_ALMENDE
	const char* const TOGGLE_LEARN_TO_DRIVE		=	"ToggleLearnToDrive";
	const char* const TOGGLE_LEARN_BIN_LOC		=	"ToggleLearnBinauralLocalization";
	const char* const TOGGLE_IMAGE_SAL			=	"ToggleImageSaliency";
	const char* const TOGGLE_AUDIO_SAL			=	"ToggleAudioSaliency";
#endif

#endif /*SIMULATIONEVENTS_H_*/
