#ifdef AUDIO_ON
/*!
 *
 * Header of the microphoneSensor
 *
 * @author Ted Schmidt
 *
 */
#ifndef MIRCOPHONESENSOR_H_
#define MIRCOPHONESENSOR_H_

#include <dtAudio/audiomanager.h>
#include "../../basic/sensors/sensorBase.h"

namespace srCore
{
	class MicrophoneSensor : public SensorBase
	{
		private:
			ALCdevice	*mydevice;
			int			freq;
			int			channels;
			int			bits;
			int			bufferSize;
			bool 		newData;

		public:
			MicrophoneSensor(BodyBase* attachedTo,osg::Vec3f pos, osg::Vec3f orient,
							const std::string &name);
			virtual ~MicrophoneSensor();
			void getParameter(const std::string &name, ParameterReturnValue  parameter);
			void setParameter(const std::string &name, ParameterReturnValue  parameter);
			void requestData();
			void evaluate(ParameterReturnValue srv);
			void setup();
			void resetMicrophone();
		protected:
			void getSensorValue(std::ostream& theStream) const;

	};
}
#endif // MICROPHONESENSOR_H_
#endif
