#!/bin/sh

# This file build.sh is created at Almende B.V. It is open-source software and part
# of the Common Hybrid Agent Platform (CHAP). A toolbox with a lot of open-source tools.
# Ranging from thread pools, and TCP/IP components to control architectures and learning
# algorithms. This software is published under the GNU Lesser General Public license, under
# version 3 (or later). You can find a version of the license on Debian (derived) systems at
# /usr/share/common-licenses/LGPL-3.

# It is not possible to add usage restrictions to a free open-source license. Nevertheless, we
# personally strongly object against this software used by the military, in the bio-industry, 
# for animal experimentation, or anything that violates the Universal Declaration of Human 
# Rights. This is, again, no usage restriction, it is a non-binding recommendation.

# Copyright © 2010 Anne van Rossum

SCRIPTDIR=`echo $PWD | grep scripts`
if [ -n "$SCRIPTDIR" ]; then
	echo "Good: We are in the scripts directory"
else
	echo "Error: We are not in the scripts directory"
	exit;
fi

cd ..
mkdir -p build
cd build
cmake ..
make -j6
ln -s ../build/libRobot3D.so ../scripts/Robot3D

echo
echo "Run program by GameStart Robot3D"
