#!/bin/sh

# This file extract_deb.sh is created at Almende B.V. It is open-source software and part
# of the Common Hybrid Agent Platform (CHAP). A toolbox with a lot of open-source tools.
# Ranging from thread pools, and TCP/IP components to control architectures and learning
# algorithms. This software is published under the GNU Lesser General Public license, under
# version 3 (or later). You can find a version of the license on Debian (derived) systems at
# /usr/share/common-licenses/LGPL-3.

# It is not possible to add usage restrictions to a free open-source license. Nevertheless, we
# personally strongly object against this software used by the military, in the bio-industry, 
# for animal experimentation, or anything that violates the Universal Declaration of Human 
# Rights. This is, again, no usage restriction, it is a non-binding recommendation.

# Copyright © 2010 Anne van Rossum

strace -f -o /tmp/log make
# or make instead of ./configure, if the package doesn't use autoconf
for x in `dpkg -S $(grep open /tmp/log|\
    perl -pe 's!.* open\(\"([^\"]*).*!$1!' |\
       grep "^/"| sort | uniq|\
       grep -v "^\(/tmp\|/dev\|/proc\)" ) 2>/dev/null|\
       cut -f1 -d":"| sort | uniq |\
       cut -f1 -d","| sort | uniq`; \
do \
    echo -n "$x (>=" `dpkg -s $x|grep ^Version|cut -f2 -d":"` "), "; \
done
