#!/bin/sh

# This file run.sh is created at Almende B.V. It is open-source software and part
# of the Common Hybrid Agent Platform (CHAP). A toolbox with a lot of open-source tools.
# Ranging from thread pools, and TCP/IP components to control architectures and learning
# algorithms. This software is published under the GNU Lesser General Public license, under
# version 3 (or later). You can find a version of the license on Debian (derived) systems at
# /usr/share/common-licenses/LGPL-3.

# It is not possible to add usage restrictions to a free open-source license. Nevertheless, we
# personally strongly object against this software used by the military, in the bio-industry, 
# for animal experimentation, or anything that violates the Universal Declaration of Human 
# Rights. This is, again, no usage restriction, it is a non-binding recommendation.

# Copyright © 2010 Anne van Rossum

# Check if yarpserver is running
RUNNING=`ps aux | grep yarp | grep server | grep -v grep`
if [ -n "$RUNNING" ]; then
	echo "Good: yarpserver is running"
else
	echo "Error: yarpserver is not running"
	echo "Just start by yarp server"
	exit;
fi

# Check if serverrun.sh is running
RUNNING=`ps aux | grep yarp | grep run | grep -v grep`
if [ -n "$RUNNING" ]; then
	echo "Good: yarprun server is running"
else
	echo "Error: yarprun server is not running"
	echo -n "  It cannot be started automatically, because you need to "
	echo "observe yarp server output till it finally stops spitting out the same message"
	echo "  It only needs to be started once."
	echo "  For example: yarp run --server GUIhost"
	exit;
fi


# Flags
if [ $# -eq 1 ]; then
	if [ $1 == "--debug" ]; then
		RUN="gdb --args "
	fi
fi

echo "Start now the Robot3D simulator"

$RUN GameStart Robot3D

echo

