//! General cuboid class.

/*!
 *
 * Describes general properties of a cuboid (or a box) in the simulation environment.
 *
 * @author Lutz Winkler
 *
 */

/*TODO: The Cuboid class is currently used for collision meshes. Maybe there should only be one base class
 * 		for representing the bodies, instead of a cylinder class, a cuboid class and so on.
 */

#include <srCore/body/cuboid.h>

#include <dtDAL/enginepropertytypes.h>
#include <dtDAL/actorproxyicon.h>
#include <dtCore/loadable.h>
#include <dtCore/isector.h>
#include <dtCore/scene.h>
#include <dtGame/gamemanager.h>
#include <dtGame/actorupdatemessage.h>
#include <dtGame/basemessages.h>
#include <dtABC/application.h>
#include <dtCore/camera.h>
#include <dtCore/keyboard.h>

namespace srCore {

Cuboid::Cuboid()
{
}

Cuboid::~Cuboid()
{
}

//! sets the collision parameter of the cuboid
void Cuboid::setCollisionBox(float length, float width, float height)
{
	this->collisionLength	=	length;
	this->collisionWidth	=	width;
	this->collisionHeight  	=	height;
	//SetCollisionBox(length, width, height);
	this->SetCollisionMesh(this->collisionModel);

}

//! sets the mass with a equal mass distribution in a cuboid with the given parameters
void Cuboid::setMass(float mass, float length, float width, float height)
{
	this->collisionLength	=	length;
	this->collisionWidth	=	width;
	this->collisionHeight  	=	height;

	dMass myMass;
	dMassSetBoxTotal(&myMass, mass, length, width, height);
	SetMass(&myMass);
	GetMass(&(this->subOrgBodyMass));
}
}

