//! General cylinder class.

/*!
 *
 * Describes general properties of a cylinder.
 *
 * @author Lutz Winkler
 *
 */

#include <srCore/body/cylinder.h>

namespace srCore {

Cylinder::Cylinder()
{
}

Cylinder::~Cylinder()
{
}

//! sets the collision parameter of the cylinder.
void Cylinder::setCollisionCylinder(float radius, float length)
{
	this->collisionLength	=	length;
	this->collisionRadius	=	radius;

	this->SetCollisionCylinder(radius, length);
}


//! sets the mass with a equal mass distribution within the parameters defined in setCollisionCylinder.
void Cylinder::setMass(float mass)
{
	dMass myMass;

	float bodyLength, bodyRadius;

	bodyLength 	= this->collisionLength;// * this->scaleX;
	bodyRadius	= this->collisionRadius;//	* this->scaleY;

	dMassSetCylinderTotal(&myMass, mass, 1, bodyRadius, bodyLength);

	SetMass(&myMass);
}

//! sets the mass with a equal mass distribution in a cylinder with the given parameters
void Cylinder::setMass(float mass, float radius, float length)
{
	dMass myMass;
	dMassSetCylinderTotal(&myMass, mass, 1, radius, length);
	SetMass(&myMass);

}

}
