/**
 * @file Robot3DComponent.cpp
 * @brief 
 *
 * This file is created at Almende B.V. It is open-source software and part of the Common 
 * Hybrid Agent Platform (CHAP). A toolbox with a lot of open-source tools, ranging from 
 * thread pools and TCP/IP components to control architectures and learning algorithms. 
 * This software is published under the GNU Lesser General Public license (LGPL).
 *
 * It is not possible to add usage restrictions to an open-source license. Nevertheless,
 * we personally strongly object against this software used by the military, in the
 * bio-industry, for animal experimentation, or anything that violates the Universal
 * Declaration of Human Rights.
 *
 * Copyright © 2010 Anne van Rossum <anne@almende.com>
 *
 * @author 	Anne C. van Rossum
 * @date	Nov 15, 2010
 * @project	Replicator FP7
 * @company	Almende B.V.
 * @case	
 */


// General files

// Plugin files
#include <srCore/robot3dComponent.h>

namespace srCore {

/* **************************************************************************************
 * Implementation of Robot3DComponent
 * **************************************************************************************/

const std::string Robot3DComponent::DEFAULT_NAME("Robot3DComponent");

Robot3DComponent::Robot3DComponent(const std::string &name): dtGame::GMComponent(name), appConfig() {

}

Robot3DComponent::~Robot3DComponent() {

}

void Robot3DComponent::ProcessMessage(const dtGame::Message &message) {
	// Do nothing
	dtGame::GMComponent::ProcessMessage(message);
}

GetConfig& Robot3DComponent::GetConfigObject() {
	return appConfig;
}

} // end of namespace srAlmende
