/*
 * Robot3D Physical realistic 3D simulator for robots
 *
 * @license GNU Lesser General Public License
 *
 * @author Lutz Winkler
 * @author Anne C. van Rossum
 */

#include <srFactory/bodyFactory.h>

//#include <srBody/frontBody.h>
//#include <srBody/backBody.h>
//#include <srBody/linkBody.h>
//#include <srBody/symbrion01.h>
//#include <srBody/symbrion02.h>
//#include <srBody/leo.h>

#include <srBody/wheel.h>
#include <srBody/kitScrew.h>
#include <srBody/kitBody1.h>
#include <srBody/kitBody2.h>

namespace srCore {

dtCore::RefPtr<BodyBase> BodyFactory::createBody(bodytype type, RobotActorBase* robot,
		float x, float y, float z,
		float heading, float pitch, float roll)
{

	switch (type)
	{

//	case FRONT_BODY:
//		return new FrontBody(robot, x, y, z,
//				heading, pitch, roll);
//
//	case BACK_BODY:
//		return new BackBody(robot, x, y, z,
//				heading, pitch, roll);
//
//	case LINK_BODY:
//		return new LinkBody(robot, x, y, z,
//				heading, pitch, roll);

	case WHEEL_BODY:
		return new Wheel(robot, x, y, z,
				heading, pitch, roll);

//	case SYMB01_BODY:
//		return new SymbrionBodyI(robot, x, y, z,
//				heading, pitch, roll);
//
//	case SYMB02_BODY:
//		return new SymbrionBodyII(robot, x, y, z,
//				heading, pitch, roll);
//
//		/// old SSSA bodies:
//	case LEO_BODY:
//		return new Leo(robot, x, y, z,
//				heading, pitch, roll);

		/// KIT robot bodies
	case KIT_1:
		return new KITBody1(robot, x, y, z,
				heading, pitch, roll);

	case KIT_2:
		return new KITBody2(robot, x, y, z,
				heading, pitch, roll);

	case KIT_SCREW:
		return new KITScrew(robot, x, y, z,
				heading, pitch, roll);

		/// SSSA robot bodies:
		//	case SSSA_BODY:
		//		return new SSSABody(robot, x, y, z,
		//				heading, pitch, roll);
		//
		//	case SSSA_ARM:
		//		return new SSSAArm(robot, x, y, z,
		//				heading, pitch, roll);
		//
		//	case SSSA_ROT:
		//		return new SSSARot(robot, x, y, z,
		//				heading, pitch, roll);
		//
		//	case SSSA_ACTIVE_WHEEL:
		//		return new SSSAActiveWheel(robot, x, y, z,
		//				heading, pitch, roll);

		//	case SSSA_PASSIVE_WHEEL:
		//		return new SSSAPassiveWheel(robot, x, y, z,
		//				heading, pitch, roll);
		//
		//
		//
		//	case WANDA_BODY:
		//			return new WandaBody(robot, x, y, z,
		//					heading, pitch, roll);
		//
		//	case SOCKET_BODY:
		//		return new SocketBody(robot, x, y, z,
		//				heading, pitch, roll);
		//
		//	case WANDA_WHEEL_BODY:
		//		return new WandaWheel(robot, x, y, z,
		//				heading, pitch, roll);


	default:
		return NULL;

	}

}
}	/*namespace*/
