/*
 * Robot3D Physical realistic 3D simulator for robots
 *
 * @license GNU Lesser General Public License
 *
 * @author Lutz Winkler
 * @author Anne C. van Rossum
 */

#include <srFactory/sensorFactory.h>


namespace srCore {

SensorType SensorFactory::getSensorTypeByName(const char *name)
{
	if (strcmp (name, "CAMERA_SENSOR") == 0) {
		return CAMERA_SENSOR;
		//    	} else if (strcmp (name, "LIGHT_SENSOR") == 0) {
		//			return LIGHT_SENSOR;
		//    	} else if(strcmp (name, "LASER_SCANNER") == 0) {
		//			return LASER_SCANNER;
		//    	} else if(strcmp (name, "DISTANCE_SENSOR") == 0) {
		//			return DISTANCE_SENSOR;
		//    	} else if(strcmp (name, "DEPTH_IMAGE_SENSOR") == 0) {
		//			return DEPTH_IMAGE_SENSOR;
		//    	} else if(strcmp (name, "SAMPLE_SENSOR") == 0) {
		//			return SAMPLE_SENSOR;
		//    	} else if(strcmp (name, "LUMINANCE_SENSOR") == 0) {
		//			return LUMINANCE_SENSOR;
		//    	} else if(strcmp (name, "MICROPHONE_SENSOR") == 0) {
		//			return MICROPHONE_SENSOR;
		//    	} else if(strcmp (name, "INFRARED_SENSOR") == 0) {
		//			return INFRARED_SENSOR;
		//    	} else if(strcmp (name, "DOCKING_SENSOR") == 0) {
		//			return DOCKING_SENSOR;
		//    	}

	}
	return UNKOWN_SENSOR;
}

dtCore::RefPtr<SensorBase> SensorFactory::createSensor(SensorType type, const std::string & name, dtCore::RefPtr<BodyBase> attachedBody, osg::Vec3f position, osg::Vec3f orientation, float apertureAngle, osg::Vec2 resolution)
{
	switch (type){
	case CAMERA_SENSOR:
		return new CameraSensor(attachedBody, position, orientation, apertureAngle, resolution, name);
		//            case LIGHT_SENSOR:
		//                return new LightSensor(attachedBody, position, orientation, apertureAngle, name);
		//            case LASER_SCANNER:
		//                return new LaserScanner(attachedBody, position, orientation, apertureAngle, resolution, name);
		//            case DISTANCE_SENSOR:
		//                return new DistanceSensor(attachedBody, position, orientation, apertureAngle, name);
		//            case DEPTH_IMAGE_SENSOR:
		//                return new DepthImageCamera(attachedBody, position, orientation, apertureAngle, resolution, name);
		//            case SAMPLE_SENSOR:
		//                return new SampleSensor(attachedBody, position, orientation, name);
	default:
		return NULL;

	}

}

SensorFactory::~SensorFactory()
{

}


}
