/**
 * @file Robot3DVocab.cpp
 * @brief 
 *
 * This file is created at Almende B.V. It is open-source software and part of the Common 
 * Hybrid Agent Platform (CHAP). A toolbox with a lot of open-source tools, ranging from 
 * thread pools and TCP/IP components to control architectures and learning algorithms. 
 * This software is published under the GNU Lesser General Public license (LGPL).
 *
 * It is not possible to add usage restrictions to an open-source license. Nevertheless,
 * we personally strongly object against this software used by the military, in the
 * bio-industry, for animal experimentation, or anything that violates the Universal
 * Declaration of Human Rights.
 *
 * Copyright © 2010 Anne van Rossum <anne@almende.com>
 *
 * @author 	Anne C. van Rossum
 * @date	Nov 19, 2010
 * @project	Replicator FP7
 * @company	Almende B.V.
 * @case	YARP
 */

// Yarp files
#include <yarp/os/Bottle.h>

// Plugin files
#include <srInterface/Robot3DVocab.h>

using namespace srInterface;
using namespace yarp::os;

/* **************************************************************************************
 * Implementation of Robot3DVocab
 * **************************************************************************************/

//! Default constructor
Robot3DVocab_::Robot3DVocab_() {}

//! Default destructor
Robot3DVocab_::~Robot3DVocab_() {}

/**
 * Adds a vector of strings to a bottle. This function does not clear the bottle!
 */
void Robot3DVocab_::toBottle(const std::vector<std::string> &str, Bottle &result) {
	std::vector<std::string>::const_iterator it;
	for (it = str.begin(); it != str.end(); it++) {
		result.addString((*it).c_str());
	}
}

/**
 * Adds string to bottle. This function does not clear the bottle.
 */
void Robot3DVocab_::toBottle(const std::string &str, Bottle &result) {
	result.addString(str.c_str());
}
